alphabet = list("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 .")
alphabet_size = len(alphabet)
char_to_index = {c: i for i, c in enumerate(alphabet)}
index_to_char = {i: c for i, c in enumerate(alphabet)}

import numpy as np

def normalize_energy(signal, energy_limit=2000):
    norm = np.sqrt(np.sum(signal ** 2))
    scale = np.sqrt(energy_limit) / norm
    return signal * scale